<?php 
require_once ('WDWT_updater.php');


class Business_world_updater extends WDWT_updater{

  /*first version with settings API*/
  protected $version_set_api = '1.0.50';  

  protected $old_meta_name = 'business_world_meta_date';

  protected $theme_mods_name = 'theme_mods_business-world';

 /**
  * rules for converting old param to new
  *
  * keep order from old to new
  * 
  * 
  * start from $version_set_api
  * @param types: get_param_with_old_name, get_old_colors, checkbox_to_select, option_change, widget name change, slider
  */
  protected $rules = array(
    '1.0.50' => array(
       array('old'=> "_top_post_cat_name", 'new'=>'top_post_cat_name' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "_hide_top_posts", 'new'=>'hide_top_posts' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "_hide_horizontal_tab_posts", 'new'=>'hide_horizontal_tab_posts' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "_hide_content_posts", 'new'=>'content_posts_enable' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "_content_post_cat_name", 'new'=>'content_post_cat_name' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "_hide_about_us", 'new'=>'home_middle_description_post_enable' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "_top_post_desc", 'new'=>'top_post_desc' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "_home_abaut_us_post", 'new'=>'home_middle_description_post' , 'type'=>'select_to_select_array' ),
       array('old'=> "news_magazinegs_default_layout", 'new'=>'default_layout' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "news_magazinegs_full_width", 'new'=>'full_width' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "news_magazinegs_content_area", 'new'=>'content_area' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "news_magazinegs_main_column", 'new'=>'main_column' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "news_magazinegs_pwa_width", 'new'=>'pwa_width' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "seo_seo_home_title", 'new'=>'seo_home_title' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "seo_seo_home_description", 'new'=>'seo_home_description' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "seo_seo_home_keywords", 'new'=>'seo_home_keywords' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "seo_seo_home_titletext", 'new'=>'seo_home_titletext' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "seo_seo_home_descriptiontext", 'new'=>'seo_home_descriptiontext' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "seo_seo_home_keywordstext", 'new'=>'seo_home_keywordstext' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "seo_seo_home_type", 'new'=>'seo_home_type' , 'type'=>'select_to_select_array' ),
       array('old'=> "seo_seo_home_separate", 'new'=>'seo_home_separate' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "seo_seo_single_title", 'new'=>'seo_single_title' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "seo_seo_single_description", 'new'=>'seo_single_description' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "seo_seo_single_keywords", 'new'=>'seo_single_keywords' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "seo_seo_single_type", 'new'=>'seo_single_type' , 'type'=>'select_to_select_array' ),
       array('old'=> "seo_seo_single_separate", 'new'=>'seo_single_separate' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "seo_seo_index_description", 'new'=>'seo_index_description' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "seo_seo_index_type", 'new'=>'seo_index_type' , 'type'=>'select_to_select_array' ),
       array('old'=> "seo_seo_index_separate", 'new'=>'seo_index_separate' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "news_magazine_logo_img", 'new'=>'logo_img' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "news_magazine_custom_css_enable", 'new'=>'custom_css_enable' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "news_magazine_custom_css_text", 'new'=>'custom_css_text' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "news_magazine_favicon_img", 'new'=>'favicon_img' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "news_magazine_blog_style", 'new'=>'blog_style' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "news_magazine_grab_image", 'new'=>'grab_image' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "news_magazine_show_twitter_icon", 'new'=>'twitter_icon_show' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "news_magazine_show_rss_icon", 'new'=>'show_rss_icon' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "news_magazine_show_facebook_icon", 'new'=>'facebook_icon_show' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "news_magazine_twitter_url", 'new'=>'twitter_url' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "news_magazine_rss_url", 'new'=>'rss_url' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "news_magazine_facebook_url", 'new'=>'facebook_url' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "news_magazine_favicon_enable", 'new'=>'favicon_enable' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "news_magazine_date_enable", 'new'=>'date_enable' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "news_magazine_footer_text_enable", 'new'=>'footer_text_enable' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "news_magazine_footer_text", 'new'=>'footer_text' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "news_magazine_show_google_icon", 'new'=>'google_icon_show' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "news_magazine_google_url", 'new'=>'google_url' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "news_magazineint_integrate_header_enable", 'new'=>'integrate_header_enable' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "news_magazineint_integrate_body_enable", 'new'=>'integrate_body_enable' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "news_magazineint_integrate_singletop_enable", 'new'=>'integrate_singletop_enable' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "news_magazineint_integrate_singlebottom_enable", 'new'=>'integrate_singlebottom_enable' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "news_magazineint_integration_head", 'new'=>'integration_head' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "news_magazineint_integration_body", 'new'=>'integration_body' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "news_magazineint_integration_single_top", 'new'=>'integration_single_top' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "news_magazineint_integration_single_bottom", 'new'=>'integration_single_bottom' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "news_magazineint_integration_bottom_adsense_hide", 'new'=>'news_magazineint_integration_bottom_adsense_type' , 'type'=>'checkbox_add_to_radio', 'args' => array('value' => 'none','option_type'=>'mods') ),//rename in rules 1.1.0
	   array('old'=> "news_magazineint_integration_bottom_adsense_type", 'new'=>'integration_bottom_adsense_type' , 'type'=>'get_param_with_old_name' ),
	   array('old'=> "int_integration_head_adsense_type", 'new'=>'integration_head_adsense_type' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "news_magazineint_integration_bottom_adsense", 'new'=>'integration_bottom_adsense' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "news_magazineint_integration_bottom_advertisment_picture", 'new'=>'integration_bottom_advertisment_picture' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "news_magazineint_integration_bottom_advertisment_url", 'new'=>'integration_bottom_advertisment_url' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "news_magazineint_integration_bottom_advertisment_title", 'new'=>'integration_bottom_advertisment_title' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "news_magazineint_integration_bottom_advertisment_alt", 'new'=>'integration_bottom_advertisment_alt' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "_image_height", 'new'=>'image_height' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "_page_image_height", 'new'=>'image_height_pages' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "_animation_speed", 'new'=>'animation_speed' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "_slideshow_interval", 'new'=>'slideshow_interval' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "_stop_on_hover", 'new'=>'stop_on_hover' , 'type'=>'get_param_with_old_name' ),
       array('old'=> "_top_post_categories", 'new'=>'top_post_categories' , 'type'=>'get_old_posts_cats' ),
       array('old'=> "_horizontal_tab_categories", 'new'=>'horizontal_tab_categories' , 'type'=>'get_old_posts_cats'),
       array('old'=> "_home_video_post", 'new'=>'home_video_post' , 'type'=>'select_to_select_array', 'args'=>array()),
       array('old'=> "_content_post_categories", 'new'=>'content_post_categories' , 'type'=>'get_old_posts_cats'),
       array('old'=> "_slider_in_home", 'new'=>'hide_slider' , 'type'=>'boolean_to_array'),
       array('old'=> "_hide_slider", 'new'=>'hide_slider' , 'type'=>'boolean_to_array_slide'),
       array('old'=> "_imgs_url", 'new'=>'slider_head' , 'type'=>'json_to_string'),
       array('old'=> "_imgs_href", 'new'=>'slider_head_href' , 'type'=>'json_to_string'),
       array('old'=> "_imgs_title", 'new'=>'slider_head_title' , 'type'=>'json_to_string'),
       array('old'=> "_imgs_description", 'new'=>'slider_head_desc' , 'type'=>'json_to_string'),
       array('old'=> "_effect", 'new'=>'effect' , 'type'=>'select_to_select_array'),
       array('old'=> "_title_position", 'new'=>'title_position' , 'type'=>'select_to_select_array'),
       array('old'=> "_description_position", 'new'=>'description_position' , 'type'=>'select_to_select_array'),
       array('old'=> "news_magazinety_type_headers_font", 'new'=>'text_headers_font' , 'type'=>'select_to_select_array'),
       array('old'=> "news_magazinety_type_headers_kern", 'new'=>'text_headers_kern' , 'type'=>'select_to_select_array'),
       array('old'=> "news_magazinety_type_headers_transform", 'new'=>'text_headers_transform' , 'type'=>'select_to_select_array'),
       array('old'=> "news_magazinety_type_headers_variant", 'new'=>'text_headers_variant' , 'type'=>'select_to_select_array'),
       array('old'=> "news_magazinety_type_headers_weight", 'new'=>'text_headers_weight' , 'type'=>'select_to_select_array'),
       array('old'=> "news_magazinety_type_headers_style", 'new'=>'text_headers_style' , 'type'=>'select_to_select_array'),
       array('old'=> "news_magazinety_type_primary_font", 'new'=>'text_primary_font' , 'type'=>'select_to_select_array'),
       array('old'=> "news_magazinety_type_primary_kern", 'new'=>'text_primary_kern' , 'type'=>'select_to_select_array'),
       array('old'=> "news_magazinety_type_primary_transform", 'new'=>'text_primary_transform' , 'type'=>'select_to_select_array'),
       array('old'=> "news_magazinety_type_primary_variant", 'new'=>'text_primary_variant' , 'type'=>'select_to_select_array'),
       array('old'=> "news_magazinety_type_primary_weight", 'new'=>'text_primary_weight' , 'type'=>'select_to_select_array'),
       array('old'=> "news_magazinety_type_primary_style", 'new'=>'text_primary_style' , 'type'=>'select_to_select_array'),
       array('old'=> "news_magazinety_type_inputs_font", 'new'=>'text_inputs_font' , 'type'=>'select_to_select_array'),
       array('old'=> "news_magazinety_type_inputs_kern", 'new'=>'text_inputs_kern' , 'type'=>'select_to_select_array'),
       array('old'=> "news_magazinety_type_inputs_transform", 'new'=>'text_inputs_transform' , 'type'=>'select_to_select_array'),
       array('old'=> "news_magazinety_type_inputs_variant", 'new'=>'text_inputs_variant' , 'type'=>'select_to_select_array'),
       array('old'=> "news_magazinety_type_inputs_weight", 'new'=>'text_inputs_weight' , 'type'=>'select_to_select_array'),
       array('old'=> "news_magazinety_type_inputs_style", 'new'=>'text_inputs_style' , 'type'=>'select_to_select_array'),
       array('old'=> "cc_menu_elem_back_color", 'new'=>'menu_elem_back_color' , 'type'=>'get_old_colors', 'args'=>array('default'=>"#FFFFFF")),
       array('old'=> "cc_sideb_background_color", 'new'=>'sideb_background_color' , 'type'=>'get_old_colors', 'args'=>array('default'=>"#FFFFFF")),
       array('old'=> "cc_footer_sideb_background_color", 'new'=>'footer_sideb_background_color' , 'type'=>'get_old_colors', 'args'=>array('default'=>"#FFFFFF")),
       array('old'=> "cc_footer_back_color", 'new'=>'footer_back_color' , 'type'=>'get_old_colors', 'args'=>array('default'=>"#FFFFFF")),
       array('old'=> "cc_featured_posts_color", 'new'=>'featured_posts_color' , 'type'=>'get_old_colors', 'args'=>array('default'=>"#F9F9F9")),
       array('old'=> "cc_text_headers_color", 'new'=>'text_headers_color' , 'type'=>'get_old_colors', 'args'=>array('default'=>"#000000")),
       array('old'=> "cc_primary_text_color", 'new'=>'primary_text_color' , 'type'=>'get_old_colors', 'args'=>array('default'=>"#000000")),
       array('old'=> "cc_footer_text_color", 'new'=>'footer_text_color' , 'type'=>'get_old_colors', 'args'=>array('default'=>"#2C2C2C")),
       array('old'=> "cc_primary_links_color", 'new'=>'primary_links_color' , 'type'=>'get_old_colors', 'args'=>array('default'=>"#545454")),
       array('old'=> "cc_primary_links_hover_color", 'new'=>'primary_links_hover_color' , 'type'=>'get_old_colors', 'args'=>array('default'=>"#007087")),
       array('old'=> "cc_menu_links_color", 'new'=>'menu_links_color' , 'type'=>'get_old_colors', 'args'=>array('default'=>"#373737")),
       array('old'=> "cc_menu_links_hover_color", 'new'=>'menu_links_hover_color' , 'type'=>'get_old_colors', 'args'=>array('default'=>"#000000")),
       array('old'=> "cc_hover_menu_item", 'new'=>'hover_menu_item' , 'type'=>'get_old_colors', 'args'=>array('default'=>"#FFFFFF")),
       array('old'=> "cc_selected_menu_color", 'new'=>'selected_menu_color' , 'type'=>'get_old_colors', 'args'=>array('default'=>"#FFFFFF")),
       array('old'=> "cc_meta_info_color", 'new'=>'meta_info_color' , 'type'=>'get_old_colors', 'args'=>array('default'=>"#8F8F8F")),
       array('old'=> "cc_logo_text_color", 'new'=>'logo_text_color' , 'type'=>'get_old_colors', 'args'=>array('default'=>"#007087")),
       array('old'=> "cc_borders_color", 'new'=>'borders_color' , 'type'=>'get_old_colors', 'args'=>array('default'=>"#007087")),
       array('old'=> "cc_slider_text_color", 'new'=>'slider_text_color' , 'type'=>'get_old_colors', 'args'=>array('default'=>"#FFFFFF")),
       array('old'=> "cc_button_background_color", 'new'=>'button_background_color' , 'type'=>'get_old_colors', 'args'=>array('default'=>"#FFFFFF")),
       array('old'=> "cc_button_text_color", 'new'=>'button_text_color' , 'type'=>'get_old_colors', 'args'=>array('default'=>"#FFFFFF")),
       array('old'=> "cc_content_post_bg_color", 'new'=>'content_post_bg_color' , 'type'=>'get_old_colors', 'args'=>array('default'=>"#FFFFFF")), 
	   array('old'=> "lightbox_bg_color", 'new'=>'lightbox_bg_color' , 'type'=>'get_old_colors', 'args'=>array('default'=>"#000000",'new_param'=>true)),
       array('old'=> "lightbox_ctrl_cont_bg_color", 'new'=>'lightbox_ctrl_cont_bg_color' , 'type'=>'get_old_colors', 'args'=>array('default'=>"#000000",'new_param'=>true)),
       array('old'=> "lightbox_title_color", 'new'=>'lightbox_title_color' , 'type'=>'get_old_colors', 'args'=>array('default'=>"#FFFFFF",'new_param'=>true)),
       array('old'=> "lightbox_ctrl_btn_color", 'new'=>'lightbox_ctrl_btn_color' , 'type'=>'get_old_colors', 'args'=>array('default'=>"#FFFFFF",'new_param'=>true)),
       array('old'=> "lightbox_close_rl_btn_hover_color", 'new'=>'lightbox_close_rl_btn_hover_color' , 'type'=>'get_old_colors', 'args'=>array('default'=>"#FFFFFF",'new_param'=>true)),
       ),
  );
  
  /**
  *  meta content should not be changed
  * only name
  *
  */
  protected $rules_meta = array(
       '1.0.50' => array(
       array('old'=> "layout", 'new'=>'default_layout' ),
       array('old'=> "content_width", 'new'=>'content_area' ),
       array('old'=> "main_col_width", 'new'=>'main_column' ),
       array('old'=> "pr_widget_area_width", 'new'=>'pwa_width' ),
       array('old'=> "fullwidthpage", 'new'=>'full_width' ),
       array('old'=> "blogstyle", 'new'=>'blog_style' ),
       array('old'=> "categories", 'new'=>'categories', 'type'=>'get_old_posts_cats_meta' ),
       array('old'=> "percent_title", 'new'=>'percent_title', 'type'=>'json_to_string_meta' ),
       array('old'=> "percent_percent", 'new'=>'percent_percent', 'type'=>'json_to_string_meta' ),
       array('old'=> "percent_header_color", 'new'=>'percent_header_color', 'type'=>'get_new_color_value' ),
       array('old'=> "percent_background_color", 'new'=>'percent_background_color', 'type'=>'get_new_color_value' ),
       array('old'=> "percent_completed_color", 'new'=>'percent_completed_color', 'type'=>'get_new_color_value' ),
       array('old'=> "percent_to_do_color", 'new'=>'percent_to_do_color', 'type'=>'get_new_color_value' ),
       array('old'=> "percent_text_color", 'new'=>'percent_text_color', 'type'=>'get_new_color_value' ),
       array('old'=> "categories_for_loc", 'new'=>'categories_for_loc', 'type'=>'get_old_posts_cats_meta' ),
	   array('old'=> "_single_post_soe_title", 'new'=>'seo_single_title', 'external' => true ),
       array('old'=> "_single_post_soe_description", 'new'=>'seo_single_description', 'external' => true ),
       array('old'=> "_single_post_soe_keywords", 'new'=>'seo_single_keywords', 'external' => true ),
       ),
  );
  
  
/**
 *  widget content should not be changed
 * only name
 *
 */
  protected $rules_widget = array();
  

  /**
  * get colors created with theme mods
  * $args=array('default'=>'','title'=>'')
  */

  protected function get_old_colors( $val, $param_name, $args=array()){
     $this->options['color_scheme']['active']=0;
     $this->options['color_scheme']['themes']=array(
        array("name" => "theme_1", "title" => "Color Scheme 1",),
        array("name" => "theme_2", "title" => "Color Scheme 2",),
        array("name" => "theme_3", "title" => "Color Scheme 3",),
        array("name" => "theme_4", "title" => "Color Scheme 4",),
        array("name" => "theme_5", "title" => "Color Scheme 5",),
      );
	if($val == null) 
      $val = $args['default'];
    $this->options['color_scheme']['colors'][0][$param_name]=  array(
        'value' => $val,
        'default' => $args['default']
    );
    
    $this->options['color_scheme']['colors'][1]=array(
      "menu_elem_back_color"          =>array('value' => "#FFFFFF",
                                                                    'default' =>"#FFFFFF"),                
      "borders_color"                 =>array('value' => "#007087",
                                                                    'default' =>"#007087"),                
      "slider_text_color" 			  =>array('value' => "#FFFFFF",
                                                                    'default' =>"#FFFFFF"),                
      "sideb_background_color"        =>array('value' => "#FFFFFF",
                                                                    'default' =>"#FFFFFF"),                
      "content_post_bg_color"         =>array('value' => "#FAFAFA",
                                                                    'default' =>"#FAFAFA"),                
      "footer_sideb_background_color" =>array('value' => "#FFFFFF",
                                                                    'default' =>"#FFFFFF"),                
      "footer_back_color"             =>array('value' => "#FFFFFF",
                                                                    'default' =>"#FFFFFF"),                
      "featured_posts_color"          =>array('value' => "#F9F9F9",
                                                                    'default' =>"#F9F9F9"),                
      "text_headers_color"            =>array('value' => "#000000",
                                                                    'default' =>"#000000"),                
      "primary_text_color"            =>array('value' => "#000000",
                                                                    'default' =>"#000000"),                
      "footer_text_color"             =>array('value' => "#2C2C2C",
                                                                    'default' =>"#2C2C2C"),                
      "primary_links_color"           =>array('value' => "#545454",
                                                                    'default' =>"#545454"),                
      "primary_links_hover_color"     =>array('value' => "#007087",
                                                                    'default' =>"#007087"),                
      "menu_links_color"              =>array('value' => "#373737",
                                                                    'default' =>"#373737"),                
      "menu_links_hover_color"        =>array('value' => "#000000",
                                                                    'default' =>"#000000"),                
      "hover_menu_item"               =>array('value' => "#FFFFFF",
                                                                    'default' =>"#FFFFFF"),                
      "selected_menu_color"           =>array('value' => "#FFFFFF",
                                                                    'default' =>"#FFFFFF"),                
      "logo_text_color"               =>array('value' => "#007087",
                                                                    'default' =>"#007087"),                
      "button_background_color"       =>array('value' => "#007087",
                                                                    'default' =>"#007087"),                
      "button_text_color"             =>array('value' => "#FFFFFF",
                                                                    'default' =>"#FFFFFF"),                
      "meta_info_color"               =>array('value' => "#8F8F8F", 
	                                                                'default' =>"#8F8F8F"),                                                                                   
      "lightbox_bg_color"             =>array('value' => "#000000",
                                                                    'default' =>"#000000"),                
      "lightbox_ctrl_cont_bg_color"   =>array('value' => "#000000",
                                                                    'default' =>"#000000"),                
      "lightbox_title_color"          =>array('value' => "#FFFFFF",
                                                                    'default' =>"#FFFFFF"),                
      "lightbox_ctrl_btn_color"       =>array('value' => "#FFFFFF",
                                                                    'default' =>"#FFFFFF"),                
      "lightbox_close_rl_btn_hover_color"  =>array('value' => "#FFFFFF",
                                                                    'default' =>"#FFFFFF"),
    );
    $this->options['color_scheme']['colors'][2]=array(
       "menu_elem_back_color"          =>array('value' => "#FFFFFF",
                                                                    'default' =>"#FFFFFF"),                
      "borders_color"                 =>array('value' => "#870000",
                                                                    'default' =>"#870000"),                
      "slider_text_color" 			  =>array('value' => "#FFFFFF",
                                                                    'default' =>"#FFFFFF"),                
      "sideb_background_color"        =>array('value' => "#FFFFFF",
                                                                    'default' =>"#FFFFFF"),                
      "content_post_bg_color"         =>array('value' => "#FAFAFA",
                                                                    'default' =>"#FAFAFA"),                
      "footer_sideb_background_color" =>array('value' => "#FFFFFF",
                                                                    'default' =>"#FFFFFF"),                
      "footer_back_color"             =>array('value' => "#FFFFFF",
                                                                    'default' =>"#FFFFFF"),                
      "featured_posts_color"          =>array('value' => "#F9F9F9",
                                                                    'default' =>"#F9F9F9"),                
      "text_headers_color"            =>array('value' => "#000000",
                                                                    'default' =>"#000000"),                
      "primary_text_color"            =>array('value' => "#000000",
                                                                    'default' =>"#000000"),                
      "footer_text_color"             =>array('value' => "#2C2C2C",
                                                                    'default' =>"#2C2C2C"),                
      "primary_links_color"           =>array('value' => "#545454",
                                                                    'default' =>"#545454"),                
      "primary_links_hover_color"     =>array('value' => "#870000",
                                                                    'default' =>"#870000"),                
      "menu_links_color"              =>array('value' => "#373737",
                                                                    'default' =>"#373737"),                
      "menu_links_hover_color"        =>array('value' => "#000000",
                                                                    'default' =>"#000000"),                
      "hover_menu_item"               =>array('value' => "#FFFFFF",
                                                                    'default' =>"#FFFFFF"),                
      "selected_menu_color"           =>array('value' => "#FFFFFF",
                                                                    'default' =>"#FFFFFF"),                
      "logo_text_color"               =>array('value' => "#870000",
                                                                    'default' =>"#870000"),                
      "button_background_color"       =>array('value' => "#870000",
                                                                    'default' =>"#870000"),                
      "button_text_color"             =>array('value' => "#FFFFFF",
                                                                    'default' =>"#FFFFFF"),                
      "meta_info_color"               =>array('value' => "#8F8F8F",
                                                                    'default' =>"#8F8F8F"),
	  "lightbox_bg_color"             =>array('value' => "#000000",
                                                                    'default' =>"#000000"),                
      "lightbox_ctrl_cont_bg_color"   =>array('value' => "#000000",
                                                                    'default' =>"#000000"),                
      "lightbox_title_color"          =>array('value' => "#FFFFFF",
                                                                    'default' =>"#FFFFFF"),                
      "lightbox_ctrl_btn_color"       =>array('value' => "#FFFFFF",
                                                                    'default' =>"#FFFFFF"),                
      "lightbox_close_rl_btn_hover_color"  =>array('value' => "#FFFFFF",
                                                                    'default' =>"#FFFFFF"),																
    );
    $this->options['color_scheme']['colors'][3]=array(
      "menu_elem_back_color"          =>array('value' => "#FFFFFF",
                                                                    'default' =>"#FFFFFF"),                
      "borders_color"                 =>array('value' => "#307900",
                                                                    'default' =>"#307900"),                
      "slider_text_color" 			  =>array('value' => "#FFFFFF",
                                                                    'default' =>"#FFFFFF"),                
      "sideb_background_color"        =>array('value' => "#FFFFFF",
                                                                    'default' =>"#FFFFFF"),                
      "content_post_bg_color"         =>array('value' => "#FAFAFA",
                                                                    'default' =>"#FAFAFA"),                
      "footer_sideb_background_color" =>array('value' => "#FFFFFF",
                                                                    'default' =>"#FFFFFF"),                
      "footer_back_color"             =>array('value' => "#FFFFFF",
                                                                    'default' =>"#FFFFFF"),                
      "featured_posts_color"          =>array('value' => "#F9F9F9",
                                                                    'default' =>"#F9F9F9"),                
      "text_headers_color"            =>array('value' => "#000000",
                                                                    'default' =>"#000000"),                
      "primary_text_color"            =>array('value' => "#000000",
                                                                    'default' =>"#000000"),                
      "footer_text_color"             =>array('value' => "#2C2C2C",
                                                                    'default' =>"#2C2C2C"),                
      "primary_links_color"           =>array('value' => "#545454",
                                                                    'default' =>"#545454"),                
      "primary_links_hover_color"     =>array('value' => "#307900",
                                                                    'default' =>"#307900"),                
      "menu_links_color"              =>array('value' => "#373737",
                                                                    'default' =>"#373737"),                
      "menu_links_hover_color"        =>array('value' => "#000000",
                                                                    'default' =>"#000000"),                
      "hover_menu_item"               =>array('value' => "#FFFFFF",
                                                                    'default' =>"#FFFFFF"),                
      "selected_menu_color"           =>array('value' => "#FFFFFF",
                                                                    'default' =>"#FFFFFF"),                
      "logo_text_color"               =>array('value' => "#307900",
                                                                    'default' =>"#307900"),                
      "button_background_color"       =>array('value' => "#307900",
                                                                    'default' =>"#307900"),                
      "button_text_color"             =>array('value' => "#FFFFFF",
                                                                    'default' =>"#FFFFFF"),                
      "meta_info_color"               =>array('value' => "#8F8F8F",
                                                                    'default' =>"#8F8F8F"),
	  "lightbox_bg_color"             =>array('value' => "#000000",
                                                                    'default' =>"#000000"),                
      "lightbox_ctrl_cont_bg_color"   =>array('value' => "#000000",
                                                                    'default' =>"#000000"),                
      "lightbox_title_color"          =>array('value' => "#FFFFFF",
                                                                    'default' =>"#FFFFFF"),                
      "lightbox_ctrl_btn_color"       =>array('value' => "#FFFFFF",
                                                                    'default' =>"#FFFFFF"),                
      "lightbox_close_rl_btn_hover_color" =>array('value' => "#FFFFFF",
                                                                    'default' =>"#FFFFFF"),															
      );
    $this->options['color_scheme']['colors'][4]=array(
      "menu_elem_back_color"          =>array('value' => "#FFFFFF",
                                                                    'default' =>"#FFFFFF"),                
      "borders_color"                 =>array('value' => "#CF8800",
                                                                    'default' =>"#CF8800"),                
      "slider_text_color" 			  =>array('value' => "#FFFFFF",
                                                                    'default' =>"#FFFFFF"),                
      "sideb_background_color"        =>array('value' => "#FFFFFF",
                                                                    'default' =>"#FFFFFF"),                
      "content_post_bg_color"         =>array('value' => "#FAFAFA",
                                                                    'default' =>"#FAFAFA"),                
      "footer_sideb_background_color" =>array('value' => "#FFFFFF",
                                                                    'default' =>"#FFFFFF"),                
      "footer_back_color"             =>array('value' => "#FFFFFF",
                                                                    'default' =>"#FFFFFF"),                
      "featured_posts_color"          =>array('value' => "#F9F9F9",
                                                                    'default' =>"#F9F9F9"),                
      "text_headers_color"            =>array('value' => "#000000",
                                                                    'default' =>"#000000"),                
      "primary_text_color"            =>array('value' => "#000000",
                                                                    'default' =>"#000000"),                
      "footer_text_color"             =>array('value' => "#2C2C2C",
                                                                    'default' =>"#2C2C2C"),                
      "primary_links_color"           =>array('value' => "#545454",
                                                                    'default' =>"#545454"),                
      "primary_links_hover_color"     =>array('value' => "#CF8800",
                                                                    'default' =>"#CF8800"),                
      "menu_links_color"              =>array('value' => "#373737",
                                                                    'default' =>"#373737"),                
      "menu_links_hover_color"        =>array('value' => "#000000",
                                                                    'default' =>"#000000"),                
      "hover_menu_item"               =>array('value' => "#FFFFFF",
                                                                    'default' =>"#FFFFFF"),                
      "selected_menu_color"           =>array('value' => "#FFFFFF",
                                                                    'default' =>"#FFFFFF"),                
      "logo_text_color"               =>array('value' => "#CF8800",
                                                                    'default' =>"#CF8800"),                
      "button_background_color"       =>array('value' => "#CF8800",
                                                                    'default' =>"#CF8800"),                
      "button_text_color"             =>array('value' => "#FFFFFF",
                                                                    'default' =>"#FFFFFF"),                
      "meta_info_color"               =>array('value' => "#8F8F8F",
                                                                    'default' =>"#8F8F8F"), 
	  "lightbox_bg_color"             =>array('value' => "#000000",
                                                                    'default' =>"#000000"),                
      "lightbox_ctrl_cont_bg_color"   =>array('value' => "#000000",
                                                                    'default' =>"#000000"),                
      "lightbox_title_color"          =>array('value' => "#FFFFFF",
                                                                    'default' =>"#FFFFFF"),                
      "lightbox_ctrl_btn_color"       =>array('value' => "#FFFFFF",
                                                                    'default' =>"#FFFFFF"),                
      "lightbox_close_rl_btn_hover_color" =>array('value' => "#FFFFFF",
                                                                    'default' =>"#FFFFFF"),															
       );
   
    
    $this->options['colors_active']['select_theme'] ='color_scheme';
    $this->options['colors_active']['active'] ='0';
    $this->options['colors_active']['colors'][$param_name] = array(
        'value' => $val,
        'default' => $args['default'],
    );
  
  


  }
  




}

